//Particle.cpp - A class to model the motion of various particles

#include <math.h>
#include "Particle.h"

particle::particle(int startpos,	//y-axis distance from 'ground'
				   float energy,	//how hard was it 'thrown'? (0->1)
				   float angle,		//0 degrees = vertical
				   float gravity,	//-9.8 = normal
				   float maxheight)	//how high is it going to go?
{
	spos = (float)startpos;
	posy = (float)startpos;
	posx = 0.0f;
	height = (maxheight*energy);
	width = 0.0f;
	this->energy = energy;
	//this->angle = angle;
	calcAngle(angle);
	this->gravity = gravity;

	time = 0.0f;
	timeinc = (energy * 0.25f) + 0.001f;
}

particle::~particle()
{

}

void particle::fakeconstructor(int startpos,	//y-axis distance from 'ground'
							   float energy,	//how hard was it 'thrown'? (0->1)
							   float angle,		//0 degrees = vertical
							   float gravity,	//-9.8 = normal
							   float maxheight)	//how high is it going to go?
{
	spos = (float)startpos;
	posy = (float)startpos;
	posx = 0.0f;
	height = (maxheight*energy);
	width = 0.0f;
	this->energy = energy;
	//this->angle = angle;
	calcAngle(angle);
	this->gravity = gravity;

	time = 0.0f;
	timeinc = (energy * 0.25f) + 0.001f;
}

bool particle::updatePos(int *x, int *y)
{
	if(posy <= 0.0f)
		return false;

	time += timeinc;

	calcVertical();
	*y = (int)posy;
	calcHorizontal();
	*x = (int)posx;

	return true;
}

void particle::calcVertical()
{
	if(time < PI)
	{
		posy = ((float)sin(time)*height)+spos;
	}
	else
	{
		posy -= (time/(0.7f*PI));
	}
}

void particle::calcHorizontal()
{
	posx += angle;
}

void particle::calcAngle(float Ang)
{
	if(Ang < 90.0f)
	{
		angle = Ang/90.0f;
		angle *= (4.0f*energy);
	}
	else if(Ang > 270.0f)
	{
		angle = Ang - 270.0f;
		angle /= 90.0f;
		angle *= ((-4.0f)*energy);
	}
	else if(Ang < 180.0f)
	{
		angle = Ang - 90.0f;
		angle /= 90.0f;
		angle *= (4.0f*energy);
	}
	else if(Ang < 270.0f)
	{
		angle = Ang - 180.0f;
		angle /= 90.0f;
		angle *= ((-4.0f)*energy);
	}
	else
		angle = 0.0f;
}