//Particle.h - A class to model the motion of various particles

#ifndef _PARTICLE_H_
#define _PARTICLE_H_

#ifndef PI
#define PI 3.14159265358979323846f
#endif

class particle
{
  public:
	particle() {};
	particle(int startpos,		//y-axis distance from 'ground'
			 float energy,		//how hard was it 'thrown'?
			 float angle,		//0 degrees = vertical
			 float gravity,		//-9.8 = normal
			 float maxheight);	//how high is it going to go?
	virtual ~particle();

	virtual void fakeconstructor(int startpos,		//y-axis distance from 'ground'
								 float energy,		//how hard was it 'thrown'?
								 float angle,		//0 degrees = vertical
								 float gravity,		//-9.8 = normal
								 float maxheight);	//how high is it going to go?

	virtual bool updatePos(int *x, int *y);
  protected:
	virtual void calcVertical();
	virtual void calcHorizontal();
	virtual void calcAngle(float ang);

	float time, timeinc;
	float posx, posy, spos;
	float height, width;
	float energy, angle;
	float gravity;
};

#endif