//wxParticleFrame.cpp

#include "wx/wxprec.h"

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

//#include <wx/settings.h>

#include "pa_common\pa_lib.c"
//#include "pa_common\portaudio.h"
#include "pa_common\pa_host.h"

#include "pa_win_wmme\pa_win_wmme.c"

#include <stdlib.h>
#include "wxParticleFrame.h"

BEGIN_EVENT_TABLE(wxParticleFrame, wxFrame)
	EVT_SIZE(wxParticleFrame::OnSize)
	EVT_PAINT(wxParticleFrame::OnPaint)
	EVT_TIMER(100005, wxParticleFrame::OnTimer)
END_EVENT_TABLE()

int patestCallback(void *inputBuffer, void *outputBuffer, unsigned long framesPerBuffer, PaTimestamp outTime, void *userData)
{
    unsigned int i, j;
	//Cast data passed through stream to our structure type.
    paTestData *data = (paTestData*)userData;
    float *out = (float*)outputBuffer;

	float temp, out_left, out_right, tempPart;

	tempPart = 1.0f/(float)data->no_Particles;

    for( i=0; i<framesPerBuffer; i++ )
    {
		//Stereo channels are interleaved.
        /*out++ = (data->left_phase * 0.125f);              //left
        *out++ = (data->right_phase * 0.125f);             //right*/

		/*modval = mod.getsample(5.0f);
		modval += 1.0f;
		modval *= 0.25f;
		modval += 0.5f;

		temp_l = osc_l.getsample(440.0f);
		temp_r = osc_r.getsample(357.0f);*/

		temp = 0.0f;
		out_left = 0.0f;
		out_right = 0.0f;

		for(j=0;j<data->no_Particles;j++)
		{
			temp = (data->oscs[j].getsample(data->freq[j]) * data->amp[j]);
			out_left += temp * (1.0f-data->pan[j]);
			out_right += temp * data->pan[j];
		}
		//temp *= tempPart;
		out_left *= tempPart;
		out_right *= tempPart;

		*out++ = out_left;
		*out++ = out_right;

		//Generate simple sawtooth phaser that ranges between -1.0 and 1.0.
        //data->left_phase += 0.01f;
		//When signal reaches top, drop back down.
        //if( data->left_phase >= 1.0f ) data->left_phase -= 2.0f;

		//higher pitch so we can distinguish left and right.
        //data->right_phase += 0.03f; 
        //if( data->right_phase >= 1.0f ) data->right_phase -= 2.0f;
    }
    return 0;
}


wxParticleFrame::wxParticleFrame(const wxChar *title,
							 int xpos,
							 int ypos,
							 int width,
							 int height,
							 int noParticles)
			 : wxFrame((wxFrame *)NULL,
					   -1,
					   title,
					   wxPoint(xpos, ypos),
					   wxSize(width, height))
{
	int temp65, temp66;
	int tempred, tempgreen, tempblue;

	PaError err;

	data.no_Particles = noParticles;

	data.oscs = 0;
	data.oscs = new simpsquosc[noParticles];
	data.freq = 0;
	data.freq = new float[noParticles];
	data.amp = 0;
	data.amp = new float[noParticles];
	data.pan = 0;
	data.pan = new float[noParticles];

	party = 0;
	party = new particle[noParticles];
	xp = 0;
	xp = new int[noParticles];
	col = 0;
	col = new wxColour[noParticles];

	srand((unsigned)time(NULL));

	for(int i=0;i<data.no_Particles;i++)
	{
		temp65 = (float)rand()/(float)RAND_MAX;
		temp65 *= (float)height;
		//xp[i] = temp65;
		xp[i] = 175.0f;
		temp66 = (float)rand()/(float)RAND_MAX;

		party[i].fakeconstructor((int)temp65, temp66, 0.0f, 0.0f, 150.0f);

		tempred = (int)(temp66*255.0f);
		temp66 = (float)rand()/(float)RAND_MAX;
		tempgreen = (int)(temp66*255.0f);
		temp66 = (float)rand()/(float)RAND_MAX;
		tempblue = (int)(temp66*255.0f);

		col[i].Set(tempred, tempgreen, tempblue);

		data.oscs[i].fakeconstructor(44100.0f, 440.0f);
		data.freq[i] = 440.0f;
		data.amp[i] = 0.0f;
		data.pan[i] = 0.0f;
	}

	//wxMessageDialog temp1(this, "Ok to Initialise?", "PortAudio Test");
	//temp1.ShowModal();
	err = Pa_Initialize();
	if(err != paNoError)
	{
		UhOh = true;
		wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
		temp.ShowModal();
		return;
	}
	else
		UhOh = false;

	//wxMessageDialog temp2(this, "Ok to open default stream?", "PortAudio Test");
	//temp2.ShowModal();
	err = Pa_OpenDefaultStream(
    &stream,        /* passes back stream pointer */
    0,              /* no input channels */
    2,              /* stereo output */
    paFloat32,      /* 32 bit floating point output */
    44100,          /* sample rate */
    256,            /* frames per buffer */
    0,              /* number of buffers, if zero then use default minimum */
    patestCallback, /* specify our custom callback */
    &data);        /* pass our data through to callback */
	if(err != paNoError)
	{
		UhOh = true;
		wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
		temp.ShowModal();
		return;
	}
	else
		UhOh = false;

	//wxMessageDialog temp3(this, "Ok to start stream?", "PortAudio Test");
	//temp3.ShowModal();
	err = Pa_StartStream(stream);
	if(err != paNoError)
	{
		UhOh = true;
		wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
		temp.ShowModal();
		return;
	}
	else
		UhOh = false;

	//SetBackgroundColour(wxColour(218, 218, 225));
	//SetForegroundColour(wxColour(0, 0, 0));
	//wxSystemSettings Settings();
	SetBackgroundColour(wxColour(0, 0, 0));
	SetForegroundColour(wxColour(218, 218, 225));

	//party = 0;
	tim = 0;

	tim = new wxTimer(this, 100005);
	tim->Start(10);
}

wxParticleFrame::~wxParticleFrame()
{
	PaError err;

	if(UhOh == false)
	{
		//wxMessageDialog temp1(this, "Ok to stop stream?", "PortAudio Test");
		//temp1.ShowModal();
		err = Pa_StopStream(stream);
		if(err != paNoError)
		{
			wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
			temp.ShowModal();
		}

		//wxMessageDialog temp2(this, "Ok to close stream?", "PortAudio Test");
		//temp2.ShowModal();
		err = Pa_CloseStream(stream);
		if(err != paNoError)
		{
			wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
			temp.ShowModal();
		}

		//wxMessageDialog temp3(this, "Ok to terminate?", "PortAudio Test");
		//temp3.ShowModal();
		Pa_Terminate();
	}

	if(tim)
	{
		tim->Stop();
		delete tim;
	}
	if(data.oscs)
		delete [] data.oscs;
	if(data.freq)
		delete [] data.freq;
	if(data.amp)
		delete [] data.amp;
	if(data.pan)
		delete [] data.pan;

	if(xp)
		delete [] xp;
	if(col)
		delete [] col;
	if(party)
		delete [] party;
}

void wxParticleFrame::OnSize(wxSizeEvent &event)
{
	wxSize temp;

	temp = GetClientSize();

	//SetSize(temp.GetWidth(), temp.GetHeight());

	//ss->ChangeSize((temp.GetWidth()-25), (temp.GetHeight()-65));

	//if(!party)
		//party = new particle(100, 0.1f, 0.0f, 0.0f);

	//Refresh(FALSE);

	//event.Skip();
}

void wxParticleFrame::OnPaint(wxPaintEvent &event)
{
	wxSize temp;
	float temp65, temp66, temp67, temp879;
	int partposx, partposy;
	int tempred, tempgreen, tempblue;

	wxBrush Boris(wxColour(255, 255, 255), wxSOLID);

	temp = GetClientSize();

	wxPaintDC dc(this);
	wxMemoryDC offscreenDC;

    wxBitmap picture(temp.GetWidth(), temp.GetHeight());

	offscreenDC.SelectObject(picture);

	//****actual drawing part****
	wxPen Basil(wxColour(128, 128, 128), 1, wxSOLID);
	offscreenDC.SetBrush(*wxWHITE_BRUSH);
	offscreenDC.SetPen(Basil);

	/*int temp457 = rand();

	temp457 /= (RAND_MAX/2);

	offscreenDC.DrawCircle((100+temp457), (100+temp457), 3);
	offscreenDC.DrawCircle((104+temp457), (95-temp457), 3);
	offscreenDC.DrawCircle((92-temp457), (88+temp457), 3);
	offscreenDC.DrawCircle((101-temp457), (107-temp457), 3);*/

	/*if(party)
	{
		int partposx, partposy;

		if(!party->updatePos(&partposx, &partposy))
		{
			delete party;
			party = 0;
		}
		else
			offscreenDC.DrawCircle(150, (temp.GetHeight()-partposy), 3);
	}
	else
		party = new particle(1, 0.1f, 0.0f, 0.0f);*/

	for(int i=0;i<data.no_Particles;i++)
	{
		tempred = col[i].Red()/2;
		tempgreen = col[i].Green()/2;
		tempblue = col[i].Blue()/2;

		Basil.SetColour(wxColour(tempred, tempgreen, tempblue));
		offscreenDC.SetPen(Basil);

		Boris.SetColour(col[i]);
		offscreenDC.SetBrush(Boris);		

		if(!party[i].updatePos(&partposx, &partposy))
		{
			temp65 = (float)rand()/(float)RAND_MAX;
			//temp65 *= (float)temp.GetHeight();
			temp65 *= 360.0f;
			temp67 = (float)rand()/(float)RAND_MAX;
			temp67 *= 100.0f;
			//xp[i] = temp67;
			xp[i] = 175.0f;
			temp66 = (float)rand()/(float)RAND_MAX;
			temp66 += 0.25f;
			temp66 *= 0.5f;
			//temp66 *= 4.0f;

			party[i].fakeconstructor(100, temp66, temp65, 0.0f, 150.0f);

			tempred = (int)(temp66*128.0f);
			tempred += 128;
			temp66 = (float)rand()/(float)RAND_MAX;
			tempgreen = (int)(temp66*255.0f);
			temp66 = (float)rand()/(float)RAND_MAX;
			tempblue = (int)(temp66*255.0f);

			col[i].Set(tempred, tempgreen, tempblue);
			data.freq[i] = 440.0f;
			data.amp[i] = 0.0f;
		}
		else
		{
			//offscreenDC.DrawCircle((xp[i]+partposx), (temp.GetHeight()-partposy), 3);
			offscreenDC.DrawCircle((xp[i]+partposx), (temp.GetHeight()-partposy), 3);

			//temp879 = (float)partposx + 265.0f;
			data.freq[i] = (float)(xp[i]+partposx) + 265.0f;
			data.amp[i] = (float)partposy * 0.004f; //0.004 = (1/250)
			data.pan[i] = (float)(xp[i]+partposx) / 350.0f; //1/350
			//data.freq[i] = 440.0f;
			//data.amp[i] = 1.0f;
		}
	}

	//****end of actual drawing part****

	dc.BeginDrawing();
	dc.Blit(0, 0, temp.GetWidth(), temp.GetHeight(), &offscreenDC, 0, 0);
	dc.EndDrawing();

	//event.Skip();
}

void wxParticleFrame::OnTimer(wxTimerEvent &event)
{
	Refresh(FALSE);
}

bool wxParticleFrame::ProcessEvent(wxEvent &event)
{
	if(event.GetEventType() == wxEVT_ERASE_BACKGROUND)
		return TRUE;
	else
		return wxEvtHandler::ProcessEvent(event);

	/*if(GetNextHandler()&&GetNextHandler()->ProcessEvent(event))
        return TRUE;
		//return wxEvtHandler::ProcessEvent(event);
    else
        //return FALSE;
		return wxEvtHandler::ProcessEvent(event);*/
}