//wxParticleFrame.h

#ifndef _WXPARTICLEFRAME_H_
#define _WXPARTICLEFRAME_H_

#define NO_PARTICLES 100
#define PART_INV 1.0f/(float)NO_PARTICLES

#include "simpsquosc.hpp"
#include "recosc.hpp"
#include "lookupsine.hpp"
#include "particle.h"

#include "pa_common\portaudio.h"

typedef struct
{
    simpsquosc *oscs;
	float *freq;
	float *amp;
	float *pan;

	int no_Particles;
}
paTestData;

class wxParticleFrame : public wxFrame
{
  public:
	wxParticleFrame(const wxChar *title,
				  int xpos,
				  int ypos,
				  int width,
				  int height,
				  int noParticles);
	~wxParticleFrame();

	virtual void OnSize(wxSizeEvent &event);
	virtual void OnPaint(wxPaintEvent &event);
	virtual void OnTimer(wxTimerEvent &event);

	virtual bool ProcessEvent(wxEvent &event);
  protected:
	wxTimer *tim;

	particle *party;
	int *xp;
	wxColour *col;
	
	PortAudioStream *stream;
	paTestData data;

	bool UhOh;

	DECLARE_EVENT_TABLE()
};

#endif